<?php if (!defined('PmWiki')) exit();
/*
    simple glossary script, version 1.03
    Copyright 2011 John Rankin (john.rankin@affinity.co.nz)
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.    
*/

## (:glossary:)
Markup('glossary', 'directives',
  '/\\(:glossary(end)?:\\)/ei',
  "PZZ(\$GLOBALS['Glossary']=('$1'!='end'))");

SDV($BlockMarkups['gl'], array('<dl class="glossary">','</dd>','</dd></dl>',1));
$HTMLStylesFmt['gls'] = "dl.glossary dt { font-style: italic; }";

## glossary lists
SDV($Glossary, false);
Markup('^G::','<^::','/^(:+)(\s*)([^:"\s]+)\s*(?:"(.*?)"(?:(.*?)")?)?:/e',
  "\$GLOBALS['Glossary'] ? '<:gl,$1,$1$2><dt id=\"$3\">$2'.('$4' ? PSS('$4') : GlossSpaced(PSS('$3'))).'</dt><dd>'
                         : PSS('$0')");
function GlossSpaced($term) { return str_replace('_',' ',$term); }

SDV($GlossaryPage, 'Glossary');
Markup('gls','inline',"/([Gg])ls(p?)\(\\s*(\\w[-\\w]*)\\s*\)/e",
  "'[[#$3 |'.GlossaryLinkText(\$pagename, '$1', '$2', '$3').']]'");
Markup('gabbr1','<inline',"/`([[:lower:]][-[:lower:]0-9]*)\\b/e",
  "AbbreviationLinkText(\$pagename, '$1')");
Markup('gabbr2','<inline',"/`([[:upper:]][-[:upper:]0-9]*)\\b(\s*\|)?/e",
  "AbbreviationLinkText(\$pagename, '$1', '$2')");
Markup('glsa','directives',"/gls\(\\s*`(\\w[-\\w]*)\\s*\)/e",
  "'[[#$1 |'.AbbreviationGlossaryText(\$pagename, '$1').']]'");

function PageGlossaryKey($pagename, $var) {
  global $PCache, $GlossaryPattern, $MaxPageTextVars;
  SDV($GlossaryPattern, 
      array('key' => '/^(:+)(\s*)([^:"\s]+)\s*(?:"(.*?)"(?:(.*?)")?)?:(.*?)$/m'));
  SDV($MaxPageTextVars, 500);
  static $status;
  if(@$status["$pagename:$var"]++ > $MaxPageTextVars) return '';
  if (!@$PCache[$pagename]['=pagetextvars']) {
    $pc = &$PCache[$pagename];
    $pc['=pagetextvars'] = 1;
    $page = RetrieveAuthPage($pagename, 'read', false, READPAGE_CURRENT);
    if ($page) {
      foreach((array)$GlossaryPattern as $pat) 
        if (preg_match_all($pat, IsEnabled($PCache[$pagename]['=preview'],
                                           preg_replace("/\n(\*\*|##)/",'<n:>$1',@$page['text'])), 
                           $match, PREG_SET_ORDER))
          foreach($match as $m)
            $pc["=p_{$m[3]}"] = array('term' => $m[4] ? trim($m[4]) : str_replace('_', ' ', $m[3]),
                                      'plur' => trim($m[5]),
                                      'desc' => str_replace('<n:>',"\n",trim($m[6])));
    }
  }
  return @$PCache[$pagename]["=p_$var"];
}

function GlossaryLinkText($page, $upper, $plural, $key) {
  global $GlossaryPage, $SeenGloss, $Charset;
  @$SeenGloss[$key]++;
  $g = PageGlossaryKey(MakePageName($page, $GlossaryPage), $key);
  $text = $g['term'] ? ($plural ? ($g['plur'] ? $g['plur'] : $g['term'].'s') : $g['term']) : '?';
  if ($upper=='G') $text[0] = strtoupper($text[0]);
  return htmlspecialchars($text, ENT_NOQUOTES, $Charset);
}

function AbbreviationLinkText($page, $key, $abb=NULL) {
  global $GlossaryPage, $SeenAbbr;
  @$SeenAbbr[$key]++;
  if ($abb) return "`$key|";
  $g = PageGlossaryKey(MakePageName($page, $GlossaryPage), $key);
  $term = strtoupper($g['term'] ? $g['term'] : $key);
  return $g['term'] ? (($SeenAbbr[$key]>1) ? '`'.$term : '{`'.$term.'|'.$g['desc'].'}') : '`'.$term;
}

function AbbreviationGlossaryText($page, $key) {
  global $SeenGloss, $SeenAbbr;
  @$SeenGloss[$key]++;  @$SeenAbbr[$key]++;
  return AbbreviationLinkText($page, $key);
}

$HTMLFooterFmt['gls'] = 'function:GlossaryList';
function GlossaryList($pagename) {
  global $GlossaryPage, $SeenGloss, $SeenAbbr, $GlossaryTag;
  SDV($GlossaryTag, array('open'  => '<div id="glossary">',
                          'head'  => '<h2 class="glossary">$Page</h2>'."\n",
                          'close' => '</div>'));
  $gpage = MakePageName($pagename, $GlossaryPage);
  $aKeys = array_keys((array)$SeenGloss);
  natcasesort($aKeys);
  $gSorted = array();
  foreach ($aKeys as $k) {
    $g = PageGlossaryKey($gpage, $k);
    if (@$SeenAbbr[$k]) $g['term'] = strtoupper($g['term']);
    $gSorted[] = ":$k".'"'.$g['term'].'":'.($g['desc'] ? $g['desc'] : '?');
  }
  echo count($gSorted) ? $GlossaryTag['open'].
                         str_replace('$Page', $GlossaryPage, $GlossaryTag['head']).
                         MarkupToHTML($pagename, "(:glossary:)\n".
                                                 implode("\n\n", $gSorted).
                                                 "\n(:glossaryend:)").
                         $GlossaryTag['close'] : '';
}

?>